import sys
import os
from jacktokenizer import JackTokenizer
from symboltable import SymbolTable
from vmwriter import VMWriter


class CompilationEngine:
    """
    This class effects the actual compilation output. Gets its input from a
    JackTokenizer and emits its parsed structure into an output file/stream.
    The output is generated by a series of compile_xxx() methods, one for every
    syntactic element xxx of the Jack grammar. The contract between these
    methods is that each compile_xxx() method should read the syntactic
    construct xxx from the input, advance() the tokenizer exactly beyond xxx,
    and output the parsing of xxx. Thus, compile_xxx() may only be called if
    indeed xxx is the next syntactic element of the input.
    """

    CLASS_LEVEL_BAR_SYMBOL = ('keyword', 'identifier')
    CLASS_LEVEL_DEC = ('keyword', 'identifier', 'symbol')
    CLASS_VAR_DEC = ('field', 'static')
    SUBROUTINE_DEC = ('constructor', 'function', 'method')
    PARAMETER_OPEN_SYMBOL = '('
    PARAMETER_CLOSE_SYMBOL = ')'
    LEFT_CURLY_BRACKET = '{'
    RIGHT_CURLY_BRACKET = '}'
    LEFT_SQUARE_BRACKET = '['
    RIGHT_SQUARE_BRACKET = ']'
    STATEMENTS = ('do', 'let', 'while', 'return', 'if', 'else')
    EXPRESSION_START_SYMBOLS = (PARAMETER_OPEN_SYMBOL, '=',
                                LEFT_SQUARE_BRACKET)
    UNARY_OPERATORS = ('-', '~')
    OPERATIONS = ('+', '*', '/', '&', '|', '<', '>', '=') + UNARY_OPERATORS
    CONSTANTS = ('integerConstant', 'stringConstant', 'keywordConstant')
    KEYWORD_CONSTANTS = ('true', 'false', 'null', 'this')
    COMMA = ','
    SEMICOLON = ';'
    TOKEN_IDX = 0
    WORD_IDX = 1
    COMPILE_ERROR = "Couldn't compile {0} in: {1}"
    MAP_SEG = {'Static': 'static', 'Field': 'this', 'Argument': 'argument',
               'Var': 'local', None: 'ERROR'}
    REP_ESCAPE = {'\t': '\\t', '\n': '\\n', '\r': '\\r', '\b': '\\b'}

    def __init__(self, jack_file):
        """
        Creates a new compilation engine with the given input and output.
        The next routine called must be build_tree().
        :param jack_file: The input jack file (str).
        """
        self.tokenizer = JackTokenizer(jack_file)
        # Initialize new tree
        self.cur_idx = -1
        self.symbol_table = None
        self.cur_class_name = None
        self.cur_subroutine_name = None
        self.cur_constructor_name = None
        self.while_idx = 0
        self.if_idx = 0
        self.code_writer = VMWriter(jack_file.replace('.jack', '.vm'))
        self.compile()
        self.close()

    def compile(self):
        """
        Compile the jack file
        :return: No return value
        """
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            if word == 'class':
                self.compile_class()
        return

    def get_token(self):
        """
        Token getter
        :return: token (str)
        """
        return self.tokenizer.token_lst[self.cur_idx][self.TOKEN_IDX]

    def get_word(self):
        """
        Word getter
        :return: Word (str)
        """
        return self.tokenizer.token_lst[self.cur_idx][self.WORD_IDX]

    def has_more_tokens(self):
        """
        checks if there are any tokens left to iterate upon.
        :return: No return value
        """
        return self.cur_idx + 1 < len(self.tokenizer.token_lst)

    def revert(self):
        """
        revert the token iterator by 1 index.
        :return: No return value
        """
        self.cur_idx -= 1

    def advance(self):
        """
        advance  the token iterator by 1 index.
        :return: No return value
        """
        self.cur_idx += 1

    def compile_class(self):
        """
        Compile a class statement tier class 
        :return: No return value
        """
        # Create a new class scope
        self.symbol_table = SymbolTable()
        self.advance()
        # Get the class name
        self.cur_class_name = self.get_word()
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            if word in self.CLASS_VAR_DEC:
                self.compile_class_var_dec()
            elif word in self.SUBROUTINE_DEC:
                self.reset_indices()
                self.compile_subroutine()
            elif word == self.RIGHT_CURLY_BRACKET:
                return

    def reset_indices(self):
        """
        Reset indices to while/if label statements
        :return: No return value
        """
        self.if_idx, self.while_idx = 0, 0

    def compile_class_var_dec(self):
        """
        Compile a class variable declaration. tier class - 2. Called by
        compile_class.
        :return: 'semi-recursive' return to sender: compile_class
        """
        # Getting the kind (static or field)
        kind = self.get_word().capitalize()
        self.advance()
        # Getting the type (int, char boolean , object class)
        symbol_type = self.get_word()
        self.advance()
        # Adding to the class scope
        self.symbol_table.define(self.get_word(), symbol_type, kind)
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            token = self.get_token()
            if token != 'symbol':
                # Adding to the class scope
                self.symbol_table.define(word, symbol_type, kind.capitalize())
            if self.get_word() == self.SEMICOLON:
                    return
        else:
            raise Exception("Couldn't compile class variable declaration")

    def compile_subroutine(self):
        """
        Compile a subroutine statement. Tier class - 2. Called by compile_class
        :return: 'semi-recursive' return to sender: compile_class
        """
        # Creating new subroutine scope
        self.symbol_table.start_subroutine()
        self.cur_subroutine_name = None
        word = self.get_word()
        if word == 'constructor':
            self.cur_subroutine_name = 'constructor'
        elif word == 'method':
            self.symbol_table.define('this', self.cur_class_name, 'Argument')
        self.advance()
        self.advance()
        if self.cur_subroutine_name != 'constructor':
            self.cur_subroutine_name = self.get_word()
        else:
            self.cur_constructor_name = self.get_word()
        # Advancing to parameter list
        self.advance()
        self.compile_parameter_list()
        self.advance()  # skip '('
        # Advancing to subroutine body parameter list
        self.compile_subroutine_body()

    def compile_parameter_list(self):
        """
        Compile a parameter list tier class - 3. Called by
        compile_subroutine_dec
        :return:  'semi-recursive' return to sender: compile_subroutine_dec
        """
        symbol_type = None
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            token = self.get_token()
            if token != 'symbol':
                # Adding to the subroutine scope
                if symbol_type is None:
                    symbol_type = word
                else:
                    self.symbol_table.define(word, symbol_type, 'Argument')
                    symbol_type = None
            if self.get_word() == ')':
                    return
        else:
            raise Exception("Couldn't compile parameter list")

    def compile_subroutine_body(self):
        """
        Compile the subroutine body tier class - 3. Called by
        compile_subroutine_dec
        :return:  'semi-recursive' return to sender: compile_subroutine_dec
        """
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            if word == 'var':
                self.advance()
                self.compile_var_dec()
            else:
                break
        self.revert()
        if self.cur_subroutine_name != 'constructor':
            call_name = self.cur_class_name + '.' + self.cur_subroutine_name
            self.code_writer.write_function(call_name, self.scope_count('Var'))
            if self.symbol_table.type_of('this'):
                self.code_writer.write_push('argument', 0)
                self.code_writer.write_pop('pointer', 0)
        else:
            call_name = self.cur_class_name + '.' + self.cur_constructor_name
            self.code_writer.write_function(call_name, self.scope_count('Var'))
            self.code_writer.write_push('constant', self.scope_count('Field'))
            self.code_writer.write_call('Memory.alloc', 1)
            self.code_writer.write_pop('pointer', 0)
        self.compile_statements()

    def scope_count(self, var):
        """
        Returns the symbol table scope counter
        :param var: variable (str)
        :return: counter (int)
        """
        return self.symbol_table.var_count(var)

    def compile_var_dec(self):
        """
        Compile a variable declaration statement tier class - 4. Called by
        compile_subroutine_body.
        :return:  'semi-recursive' return to sender: compile_subroutine_body
        """
        symbol_type = self.get_word()
        self.advance()
        self.symbol_table.define(self.get_word(), symbol_type, 'Var')
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            token = self.get_token()
            if token != 'symbol':
                # Adding variable to the subroutine scope
                self.symbol_table.define(word, symbol_type, 'Var')
            if self.get_word() == self.SEMICOLON:
                    return
        else:
            raise Exception("Couldn't compile class variable declaration")

    def compile_statements(self):
        """
        Compile a number of statements tier class - 4. Called by
        compile_subroutine_body.
        :return: 'semi-recursive' return to sender: compile_subroutine_body
        """
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            if word == "let":
                self.advance()
                self.compile_let()
            elif word == "if":
                self.advance()
                self.compile_if()
            elif word == "while":
                self.advance()
                self.compile_while()
            elif word == "do":
                self.advance()
                self.compile_do()
            elif word == "return":
                self.advance()
                self.compile_return()
            elif word == self.RIGHT_CURLY_BRACKET:
                # Important statement finished compilation without advance '}'
                return

    def compile_let(self):
        """
        Compile a 'let statement' tier class
        :return: No return value
        """
        var_name = self.get_word()
        self.advance()  # skip  '[' or '='
        if self.get_word() == '[':
            self.pop_array(var_name)
        else:
            self.pop_variable(var_name)

    def pop_array(self, var_name):
        """
        popping an array from stack in case of let statement.
        :param var_name: array name
        :return: No return value
        """
        segment = self.MAP_SEG[self.symbol_table.kind_of(var_name)]
        index = self.symbol_table.index_of(var_name)
        self.advance()  # skip '[
        self.compile_expression()
        self.advance()
        self.advance()  # skip ']'
        self.code_writer.write_push(segment, index)
        self.code_writer.write_arithmetic('add')
        self.advance()  # skip '='
        self.compile_expression()
        self.code_writer.write_pop('temp', 0)
        # Now the address of the array + index is on the stack
        self.code_writer.write_pop('pointer', 1)
        self.code_writer.write_push('temp', 0)
        self.code_writer.write_pop('that', 0)

    def pop_variable(self, var_name):
        """
        popping a variable from stack in case of let statement.
        :param var_name: Variable name
        :return: No return value
        """
        self.advance()  # skip '='
        self.compile_expression()
        segment = self.MAP_SEG[self.symbol_table.kind_of(var_name)]
        index = self.symbol_table.index_of(var_name)
        self.code_writer.write_pop(segment, index)

    def compile_if(self):
        """
        Compile a 'if statement' tier class
        :return: No return value
        """
        label_suf = str(self.if_idx)
        self.if_idx += 1
        self.advance()  # skip '('
        self.compile_expression()
        self.advance()  # skip ')'
        self.code_writer.write_if('IF_TRUE' + label_suf)
        self.code_writer.write_goto('IF_FALSE' + label_suf)
        self.code_writer.write_label('IF_TRUE' + label_suf)
        self.compile_statements()
        self.advance()  # skip '}'
        if self.get_word() == 'else':
            self.code_writer.write_goto('IF_END' + label_suf)
            self.code_writer.write_label('IF_FALSE' + label_suf)
            self.advance()  # skip '{'
            self.compile_statements()
            self.code_writer.write_label('IF_END' + label_suf)
        else:
            self.code_writer.write_label('IF_FALSE' + label_suf)
            self.revert()

    def compile_while(self):
        """
        Compile a 'while statement' tier class
        :return: No return value
        """
        label_suf = str(self.while_idx)
        self.while_idx += 1
        self.code_writer.write_label('WHILE_EXP' + label_suf)
        self.advance()  # skip '('
        self.compile_expression()
        self.code_writer.write_arithmetic('not')
        self.code_writer.write_if('WHILE_END' + label_suf)
        self.advance()  # skip ')'
        self.compile_statements()
        self.code_writer.write_goto('WHILE_EXP' + label_suf)
        self.code_writer.write_label('WHILE_END' + label_suf)

    def compile_do(self):
        """
        Compile a 'do statement' tier class - 5. Called by compile_statements
        :return: No return value
        """
        self.compile_subroutine_call()
        self.code_writer.write_pop('temp', 0)

    def compile_return(self):
        """
        Compile a 'return statement' tier class - 5. Called by
        compile_statements
        :return: No return value
        """
        if self.get_word() == ';' and self.get_token() == 'symbol':
            self.code_writer.write_push('constant', 0)
        else:
            self.compile_expression()
        self.code_writer.write_return()

    def compile_subroutine_call(self):
        """
        Compile sub subroutine call
        :return: No return value
        """
        subroutine_name = self.get_word()
        self.advance()
        num_of_expressions = 0
        if self.get_word() == '(':
            self.code_writer.write_push('pointer', 0)
            num_of_expressions = self.compile_expression_list() + 1
            self.revert()
            subroutine_name = self.cur_class_name + '.' + subroutine_name
        elif self.get_word() == '.':
            self.advance()
            kind_of = self.symbol_table.kind_of(subroutine_name)
            if kind_of:
                index_of = self.symbol_table.index_of(subroutine_name)
                subroutine_name = self.symbol_table.type_of(subroutine_name)
                self.code_writer.write_push(self.MAP_SEG[kind_of], index_of)
            subroutine_name += '.' + self.get_word()
            self.advance()  # skip '.'
            num_of_expressions = self.compile_expression_list()
            self.revert()
            if kind_of:
                num_of_expressions += 1
        self.advance()  # skip ')'
        self.code_writer.write_call(subroutine_name, num_of_expressions)

    def compile_expression_list(self):
        """
        Compile an Expression List tier class - 8. Called by compile_term
        :return:  number of expressions in the list (int)
        """
        num_of_expressions = 0
        while self.has_more_tokens():
            self.advance()
            word = self.get_word()
            token = self.get_token()
            if word == ')' and token == 'symbol':
                return num_of_expressions
            else:
                num_of_expressions += 1
                self.compile_expression()
                self.advance()
                if self.get_word() == ')' and self.get_token() == 'symbol':
                    return num_of_expressions

    def compile_expression(self):
        """
        Compile an expressions tier class - 6
        :return:  'semi-recursive' return to sender:
        """
        self.compile_term()
        while True:
            self.advance()
            word = self.get_word()
            if word in self.OPERATIONS:
                self.advance()
                self.compile_term()
                self.compile_op(word)
            else:
                self.revert()
                return

    def compile_term(self):
        """
        Compile a term tier class - 7
        :return:  'semi-recursive' return to sender:
        """
        word = self.get_word()
        token = self.get_token()
        if token == "integerConstant":
            self.code_writer.write_push("constant", int(word))
        elif token == "stringConstant":
            self.compile_string_constant(word)
        elif word in self.KEYWORD_CONSTANTS:
            self.compile_keyword_constant(word)
        elif word == '(':
            self.advance()  # Skip '('
            self.compile_expression()
            self.advance()  # Skip ')'
        elif word in self.UNARY_OPERATORS:
            self.advance()
            self.compile_term()
            self.compile_unary_op(word)
        elif word in (')', ']', ';', ','):
            # Finished expression
            self.revert()
            return
        else:
            segment = self.symbol_table.kind_of(word)
            if segment:
                self.advance()
                if self.get_word() == '[':
                    self.push_array(word, segment)
                    self.advance()
                elif self.get_word() == '.':
                    self.revert()
                    self.compile_subroutine_call()
                else:
                    index = self.symbol_table.index_of(word)
                    self.code_writer.write_push(self.MAP_SEG[segment], index)
                    self.revert()
            else:
                self.compile_subroutine_call()

    def push_array(self, var, segment):
        """
        pushing an array to stack.
        :param var: array name
        :param segment: memory segment
        :return: No return value
        """
        self.advance()  # skip '['
        self.compile_expression()
        self.code_writer.write_push(self.MAP_SEG[segment], self.scope_idx(var))
        self.code_writer.write_arithmetic('add')
        self.code_writer.write_pop('pointer', 1)
        self.code_writer.write_push('that', 0)

    def push_variable(self, var, segment):
        """
        pushing a variable to stack.
        :param var: array name
        :param segment: memory segment
        :return: No return value
        """
        self.code_writer.write_push(self.MAP_SEG[segment], self.scope_idx(var))

    def scope_idx(self, var):
        """
        Return the variable scope index
        :param var: variable in the scope (str)
        :return: index (int)
        """
        return self.symbol_table.index_of(var)

    def compile_string_constant(self, str_const):
        """
        compile string constant
        :param str_const: str_const (str)
        :return: No return value
        """
        # Every escapes character \n should be mapped to literal
        for esc_c in self.REP_ESCAPE:
            str_const = str_const.replace(esc_c, self.REP_ESCAPE[esc_c])
        self.code_writer.write_push('constant', len(str_const))
        self.code_writer.write_call('String.new', 1)
        for c in str_const:
            self.code_writer.write_push('constant', ord(c))
            self.code_writer.write_call('String.appendChar', 2)
        return

    def compile_unary_op(self, op):
        """
        compile unary operator
        :param op: unary operator (str)
        :return: No return value
        """
        if op == '-':
            self.code_writer.write_arithmetic("neg")
        elif op == '~':
            self.code_writer.write_arithmetic("not")

    def compile_op(self, op):
        """
        compile  operator
        :param op: operator (str)
        :return: No return value
        """
        if op == '+':
            self.revert()
            if self.get_token() == 'stringConstant':
                self.code_writer.write_call('String.append', 2)
            else:
                self.code_writer.write_arithmetic("add")
            self.advance()
        elif op == '-':
            self.code_writer.write_arithmetic("sub")
        elif op == '=':
            self.code_writer.write_arithmetic("eq")
        elif op == '>':
            self.code_writer.write_arithmetic("gt")
        elif op == '<':
            self.code_writer.write_arithmetic("lt")
        elif op == '&':
            self.code_writer.write_arithmetic("and")
        elif op == '|':
            self.code_writer.write_arithmetic("or")
        elif op == '*':
            self.code_writer.write_call("Math.multiply", 2)
        elif op == '/':
            self.code_writer.write_call("Math.divide", 2)

    def compile_keyword_constant(self, keyword_const):
        """
        compile keyword constant
        :param keyword_const: keyword constant(str)
        :return: No return value
        """
        if keyword_const == 'this':
            self.code_writer.write_push('pointer', 0)
        else:
            self.code_writer.write_push('constant', 0)
            if keyword_const == 'true':
                self.code_writer.write_arithmetic('not')

    def close(self):
        """
        close vm file
        :return: No return value
        """
        self.code_writer.close()

if __name__ == "__main__":
    input_str = sys.argv[1]
    if os.path.isfile(input_str)and input_str.endswith('.jack'):
            ce = CompilationEngine(input_str)
    elif os.path.isdir(input_str):
        for file in os.listdir(input_str):
            if file.endswith('.jack'):
                ce = CompilationEngine(os.path.join(input_str, file))

    else:
        print("No such input to compile")
